/*
 * PrintCoffeeBAGG.cc
 *
 *  Created on: 2010-03-11
 *      Author: albert
 */

#include "gnm.h"
#include "nfgame.h"
#include "makegame.h"
#include "libagg/agg.h"
#include "BAGG/bagg.h"
#include "agentform.h"
#include "ubcsat-time.h"

#include <iostream>
#include <iomanip>
#include <sstream>
using namespace std;

//GW gnm constants
#ifndef STEPS
  #define STEPS 100
#endif
#define FUZZ 1e-12
#ifndef LNMFREQ
  #define LNMFREQ 3
#endif
#define LNMMAX 10
#define LAMBDAMIN -0.2
#ifndef WOBBLE
  #define WOBBLE 0
#endif
#define THRESHOLD 1e-2

#define FULLSTRAT 1
#define POSPROB 0.4
#define DEBUG 0
//whether to use the full version of coffee shop game
#define FULL 1

#ifndef MAXEQL
  #define MAXEQL 1
#endif

#define DOAGG 1
#define DONF 1
#define DOINF 1
#define DOPAYOFF 0
#define DOJAC 0
#define DOSYM 0
#define DOGW 0
#define DOPRINT 1
#define PRINTFN "BAGG"

#define INTPAYOFFS 1

void usage(char *name) {
  cout<<"usage:\n";
  cout<<name
    <<" -coffee[1|2]  numPlayers numTypes numRows numCols filename gameSeed numGames"
    <<endl;

}

int main(int argc, char **argv) {
  int S,T=0,r=0,c=0, argbase=0;
  enum {SYM, COFFEE,F} gtype;
  projtype p=P_SUM;
  if (argc <3){
    usage(argv[0]);
    return -1;
  }
  int n;

  if (argc<9) {usage(argv[0]); return -1;}
  gtype=COFFEE;
  if (strcmp(argv[1], "-coffee2")==0) p = P_EXIST;
  else p=P_SUM;
  n = atoi(argv[2]);
  T=atoi(argv[3]);
  r=atoi(argv[4]);
  c=atoi(argv[5]);
  S =r*c+1;
  argbase=2;
  cerr<<"creating coffee shop BAGG with "<<n<<" players, "<<T<< " types per player on "<<r << " by "<< c<<" grid"<<endl;

  //filename = atoi(argv[4+argbase]);
  int gameSeed = atoi(argv[5+argbase]);
  int numGames =atoi(argv[6+argbase]);

 for (int i=0;i<numGames;i++){
  srand48(gameSeed+i);
  //make the AGG
  agentform *aggPtr=NULL;
  //if (gtype==SYM)
  //  aggPtr = new aggame( makeRandSymAGG (n,S,gameSeed) );
  //else


  aggPtr = new agentform( makeRandCoffeeShopBAGG(n,T,r,c,gameSeed,p, INTPAYOFFS) );
  string fn =  argv[6]; //PRINTFN;
  //fn += argv[1];

  stringstream out;
  fn+= "-";fn+=argv[2];
  fn+= "-";fn+=argv[3];
  fn+="-";fn+=argv[4];
  fn+="-";fn+=argv[5];
  fn+="_";
  out<<fn<<gameSeed+i;
  //fn+=".bagg";

  ofstream s(out.str().c_str());

  s<< *(aggPtr->baggPtr);
  s.close();
 }
}
