
#ifndef __AGGAME_H
#define __AGGAME_H

/*
** AGG for gametracer. This is a wrapper class of agg
**
*/

#include "cmatrix.h"
#include "libagg/agg.h"

class aggame : public gnmgame {
  public:

    static aggame* makeAGGame(char* filename) {
      return new aggame( agg::makeAGG(filename) );
    }


    static aggame* makeAGGame(istream& in) {
      return new aggame ( agg::makeAGG(in) );
    }

    aggame ( agg* _aggPtr)
      :gnmgame(_aggPtr->getNumPlayers(), _aggPtr->actions),
      aggPtr (_aggPtr)
    {
    }

    virtual ~aggame () {
      //delete aggPtr;
    }

    int getNumActionNodes(){return aggPtr->getNumActionNodes();}


    Number getMixedPayoff(int player, cvector &s){
      return aggPtr->getMixedPayoff(player,s);
    }

    void payoffMatrix(cmatrix &dest, cvector &s, Number fuzz){
      aggPtr->payoffMatrix(dest,s,fuzz);
    }

    void getPayoffVector(cvector &dest, int player,const cvector &s){
      aggPtr->getPayoffVector(dest,player,s);
    }
    void getSymPayoffVector(cvector& dest, cvector &s){
      aggPtr->getSymPayoffVector(dest,s);
    }
    Number getPurePayoff(int player, int* s){
      return aggPtr->getPurePayoff(player,s);
    }
    cvector getExpectedConfig(cvector &s){
      return aggPtr->getExpectedConfig(s);
    }


//  private:

    agg* aggPtr;


};

#endif
