/* Copyright 2002 Ben Blum, Christian Shelton
 *
 * This file is part of GameTracer.
 *
 * GameTracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * GameTracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GameTracer; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __MAKEGAME_H
#define __MAKEGAME_H

#include "gnmgame.h"
#include "nfgame.h"
#include "libagg/agg.h"
#include "BAGG/bagg.h"

nfgame *makeRandomNFGame(int n, int actions, int seed);
nfgame *makeNFGame(char *filename);
nfgame *makeNFGame(gnmgame* aggGame);
nfgame *makeNFGame(bagg *baggPtr);
agg* makeRandSymAGG(int n, int S, int seed);
agg* makeRandCoffeeShopAGG(int n, int r,int c,int seed,projtype  pType=P_SUM, bool full=true);
bagg* makeRandCoffeeShopBAGG(int n,int T, int r,int c,int seed,projtype pType=P_SUM, bool int_payoffs=false, int int_factor=100);
//bagg* makeJobMarketBAGG(int n);

int  getPureStrat (int *s , int index,int* blockSize,int numPlayers);


#endif
